<?php
/* Converts iPod filenames (HBUC.m4a) into Artist - Title - Album - Year - Genre.m4a
	Written by Jack Wager
	jackwager.com
*/
$baseLoc = simplexml_load_file('xml/base_location.xml');
$items = simplexml_load_file('xml/item.xml');
$itemArtists = simplexml_load_file('xml/item_artist.xml');
$itemExtras = simplexml_load_file('xml/item_extra.xml');
$albums = simplexml_load_file('xml/album.xml');
$genres = simplexml_load_file('xml/genre.xml');
$baseL = array();

foreach($baseLoc as $base) {
	if(checkBaseLoc($base['base_location_id'])) {
		continue;
	}
	$loc = (string)$base['base_location_id'];
	if(!@$baseL[$loc]) {
		$baseL[$loc] = (string)$base['path'];
	}
}

foreach($items as $item) {
	$item_pid = (string)$item['item_pid'];
	$item_artist_pid = (string)$item['item_artist_pid'];
	$album_pid = (string)$item['album_pid'];
	$base_location_id = (string)$item['base_location_id'];
	$item_artist_pid = (string)$item['item_artist_pid'];
	$album_pid = (string)$item['album_pid'];
	$genre_id = (string)$item['genre_id'];
	$artist = "";
	$title = "";
	$location = "";
	$path = "";
	$album = "";
	$genre = "";
	$year = "";
	
	if(checkBaseLoc($base_location_id)) {
		continue;
	}
	
	$path = "music/" . $baseL[$base_location_id];

	if(!$titleLoc = getTitleLocationYear($item_pid)) {
		die("item_extra: couldn't find title and location " . $item_pid);
	}
	if($item_artist_pid == "0") {
		$artist = "Unknown";
	}
	else if(!$artist = getArtist($item_artist_pid)) {
		echo "item_artist: couldn't find artist " . $item_pid . " | item_artist_pid " . $item_artist_pid . "<br/>";
	}
	list($title,$location,$year) = $titleLoc;
	
	if($album_pid == "0") {
		$album = "Unknown";
	}
	else if(!$album = getAlbum($album_pid)) {
		die("album: can't find album " . $album_pid . " | IID: " . $item_pid);
	}
	
	if($genre_id == 0) { 
		$genre = "Unknown";
	}
	else if(!$genre = getGenre($genre_id)) {
		die("genre: can't find genre " . $genre_id . " | IID: " . $item_pid);
	}
	
	$fileName = $artist . " - " . $title . " - " . $album . " - " . $year . " - " . $genre . ".m4a";
	$fileName = str_replace(array(":","?"),"",$fileName);
	if(!rename($path . "/" . $location,$path . "/" . $fileName)) {
		echo "FAILED: " . $fileName . " | IID: " . $item_pid . "<br/>";
	}
}



function checkBaseLoc($base_location_id) { //ignore 0 and whatever that long one is
	if($base_location_id == "0" || $base_location_id == "7729071494896981101") {
		return true;
	}
return false;
}

function getTitleAndLocation($item_pid) {
	global $itemExtras;
	foreach($itemExtras as $itemExtra) {
		if($itemExtra['item_pid'] == $item_pid) {
			return array((string)$itemExtra['title'],(string)$itemExtra['location']);
		}
	}
	return false;
}

function getTitleLocationYear($item_pid) {
	global $itemExtras;
	foreach($itemExtras as $itemExtra) {
		if($itemExtra['item_pid'] == $item_pid) {
			return array((string)$itemExtra['title'],(string)$itemExtra['location'],(string)$itemExtra['year']);
		}
	}
	return false;
}

function getArtist($item_artist_pid) {
	global $itemArtists;
	foreach($itemArtists as $itemArtist) {
		if($itemArtist['item_artist_pid'] == $item_artist_pid) {
			return (string)$itemArtist['item_artist'];
		}
	}
	return false;
}

function getAlbum($album_pid) {
	global $albums;
	foreach($albums as $album) {
		if($album['album_pid'] == $album_pid) {
			return (string)$album['album'];
		}
	}
	return false;
}

function getGenre($genre_id) {
	global $genres;
	foreach($genres as $genre) {
		if($genre['genre_id'] == $genre_id) {
			return $genre['genre'];
		}
	}
	return false;
}
?>